local shared = assert( require 'shared' )
local socket = assert( require 'socket' )
local udp = socket.udp()
local io = assert( io )
local server = {
  tick = 0,
  portNumber = 51312,
  logFile = assert( io.open( "../logs/dajjal"..os.time()..".txt", "a" )),
  serverName = "dajjal-server",
}

do
  local _print = print
  function server.Print(...)
    _print( ... )
    server.logFile:write( table.concat({os.date("!%Y-%m-%d %X"), ...}, "\t"), "\n" )
    server.logFile:flush()
  end
end
local print = server.Print


--Developer convenience function: start the local client program.
function server.StartLocalClient()
  os.execute( "start vision.bat" )
end

function server.Parse( packet, ip, port )
  if not packet then return end
  print( packet )
end

function server.Start()
  udp:settimeout(0)
  udp:setsockname('*', server.portNumber)
  print( "Starting Server" )
  server.StartLocalClient()
  repeat
    server.Parse( udp:receivefrom() )
    server.Advance()
  until socket.sleep( 0.1 )
end

function server.Advance()
  server.tick = server.tick + 1
end

function server.NewGame()

end

function server.Quit()

end

return server.Start()